
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from aiengine import *
from pygame.locals import *
import random

class AIEngineArchers(AIEngine):
    "1 archer moves in for 1 kill"
    def __init__(self, battlefieldgrid, team):
	AIEngine.__init__(self)
	self.grid = battlefieldgrid	
	self.team = team
	
    def work(self, o):
	o.work(self)

    def dowork(self, o):
	for i in range(0,len(self.grid)-1):
		if self.grid[i] != None:
			self.movein(self.nearest(self.grid[i]), self.grid[i])

    def nearest(self, gridmember):
	xmin = 1000000
	e1 = self.team.gameobjects[0] 
	for e in self.team:
		if math.sqrt(e.x - gridmember.x) < xmin 	
			xmin = math.abs(e.x - gridmember.x)
			e1 = e	
	return (xmin, e1)
	 
    def movein(self, xmin_e1, gridmember):
	if xmin_e1[1].x < gridmember.x:
		xmin_e1[1].x += 0.2 
