
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
import random,math

from aiengine import *
from fairycave import *

class ExplorerAIEngine(AIEngine):
    ""
    def __init__(self):
	self.dict = { 0 : 'a little', 1 : 'slightly', 2 : 'very', 3 : 'extremely',
	4 : 'very very', 5 : 'more or less', 6 : ' somewhat', 7 : 'indeeed' }	
	self.energy = 0

    def request(self, string,x,y, option=None):
	if string == "fairy cave":
		if self.fuzzylogic() < 10:
			return None
		elif self.fuzzylogic() < 20:
			r = random.randint(0,3)
			if r == 0:
				return FairyCave(x-random.randint(100,200),y-random.randint(100,200),100)
			elif r == 1: 
				return FairyCave(x+random.randint(100,200),y-random.randint(100,200), 100)
			elif r == 2: 
				return FairyCave(x-random.randint(100,200),y-random.randint(100,200),100)
			elif r == 3: 
				return FairyCave(x-random.randint(100,200),y+random.randint(100,200),100)
   
    def fuzzylogic(self):
	###r = random.randint(0, 10) 
	###if r*r > 90:
	###	return random.randint(0,40)
	###else:
	###	return 0
	case = random.randint(0,8)
	value = self.dict[case]
	r = random.randint(0,100)	
	if value == 'a little':
		r = math.pow(r, 1.3)
	elif value == 'slightly':
		r = math.pow(r, 1.7)
	elif value == 'very':
		r = math.pow(r, 2)
	elif value == 'extremely':
		r = math.pow(r, 3)
	elif value == 'very very':
		r = math.pow(r, 4)
	elif value == 'more or less':
		r = math.sqrt(r)
	elif value == 'somewhat':
		r = math.sqrt(r)
	elif value == 'indeed':
		r = 2 * math.pow(r, 2)

	self.energy += 0.001

	if r > self.energy:
		self.energy = 0
		return r
	else:
		return 0

    def work(self, o):
	o.work(self)

    def dowork(self, o):
	1
