
# Copyright (C) Johan Ceuppens 2010-2016 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from buttonwidget import *

class ImageButtonWidget(ButtonWidget):
    "Game object"
    def __init__(self, xx,yy,ww,hh,imagefilename):
	ButtonWidget.__init__(self,xx,yy,ww,hh)
        self.image = pygame.image.load(imagefilename).convert()
        self.image.set_colorkey((0,0,0)) 

    def draw(self, screen):
        screen.blit(self.image,(self.x,self.y))
	     
    def collide(self, mousetuple):
	r = 0
	if mousetuple[0] > self.x:
		r += 1
	if mousetuple[0] < self.x+self.w: 
		r += 1	
	if mousetuple[1] > self.y: 
		r += 1	
	if mousetuple[1] < self.y + self.h:
		r += 1
	return r - 3 


