
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from octtree import *
from explorercache import *

class Maproom:
    "Room with a (big) map"
    def __init__(self,x,y,width,minwidth):
        self.prevx = x
        self.prevy = y
	self.w = width
        self.relativex = 0
        self.relativey = 0
        self.background = pygame.image.load('./pics/blank.bmp').convert()

	self.octtree = Octtree(x,y,width,minwidth)
	self.gameobjects = []

	self.explorercache = ExplorerCache()

    def draw(self,screen):
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))

    def update(self, game):
	for p in game.player.gameobjects:
		p.unhover()
        (mousex, mousey) = pygame.mouse.get_pos() 
	for p in game.player.gameobjects:
		if p.collide((mousex-game.room.getrelativex(),mousey-game.room.getrelativey())) == 1:
			## print "mouse over gameobject"
			p.hover(game)

    def collideforclick(self, game):
        (mousex, mousey) = pygame.mouse.get_pos() 
	for p in game.player.gameobjects:
		if p.collide((mousex-game.room.getrelativex(),mousey-game.room.getrelativey())) == 1:
			return p	
	return None 

    def moveup(self):
	self.prevx = self.relativex
	self.prevy = self.relativey + 1
        self.relativey = self.relativey - 10

    def movedown(self):
	self.prevx = self.relativex
	self.prevy = self.relativey - 1
        self.relativey = self.relativey + 10

    def moveleft(self):
	self.prevx = self.relativex + 1
	self.prevy = self.relativey
        self.relativex = self.relativex - 10

    def moveright(self):
	self.prevx = self.relativex - 1
	self.prevy = self.relativey
        self.relativex = self.relativex + 10

    def removeobject(self, o):
        1


    def select(self,rx1,rx2,ry1,ry2):
	list = []
	for e in self.gameobjects:
		if e.collideXY(rx1+self.relativex,rx2+self.relativex,ry1+self.relativey,ry2+self.relativey):
			list.append(e)
	return list
 
    def getrelativex(self):
	return self.relativex

    def getrelativey(self):
	return self.relativey

    def setrelativex(self, xx):
	self.relativex = xx

    def setrelativey(self, yy):
	self.relativey = yy

    def getenemies(self):
	return self.gameobjects 
