
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from archerred1 import *
from fairycave import *
from darkcave import *
from exploreraiengine import *

class Maproom1(Maproom):
    "Room with a (big) map"
    def __init__(self,x,y,):
        Maproom.__init__(self,x,y,800,16)
        self.background = pygame.image.load('./pics/level1-bg.png').convert()
	self.gameobjects.append(ArcherRed1(10,10))
	self.gameobjects.append(ArcherRed1(100,10))
	self.gameobjects.append(ArcherRed1(10,100))
	self.gameobjects.append(ArcherRed1(300,300))

	####self.gameobjects.append(DarkCave(350-self.getrelativex(),250-self.getrelativey(),350-self.getrelativex(),250-self.getrelativey()))
	self.gameobjects.append(DarkCave(350,250,350,250))
 
	self.exploreraiengine = ExplorerAIEngine()

    def update(self, game):
    	Maproom.update(self, game) 

	fairycave = None ### FIXME self.exploreraiengine.request("fairy cave",self.getrelativex(),self.getrelativey())
	if fairycave:
		self.gameobjects.append(fairycave)

    def draw(self,screen):
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        for i in self.gameobjects:
	    if i != None:
		i.draw(screen,self)

    def collide(self, player):
	for i in self.gameobjects:
	    if i != None: 
		i.update(self)	
	for i in player.gameobjects:
	    if i != None: 
		i.update(self)	
	for o in self.gameobjects:
		for p in player.gameobjects:
	    		if o != None and p != None and o != p and o.collideroom(self, p):
				p.hit()
				if p.hitpoints <= 0:
					p = None
	return None 

    def exit(self, game):
	if self.relativey > 30 and self.relativex > 20:
	    game.setxy(10,-80)	
	    return 2
	else:
	    return 0 

