
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from octtreenode import *
from octtreebase import *
from octtreebasex import *
import random

class Octtree(OcttreeBase, OcttreeBaseX):
    ""
    def __init__(self,xx,yy,width,minwidth):
	OcttreeBase.__init__(self, xx,yy,width,width)
	OcttreeBaseX.__init__(self, minwidth)

	self.rootnode = None
	self.construct()

    def construct(self):
	self.rootnode = OcttreeNode(0,0,self.w)	
	self.rootnode.construct()
       	#n = self.worldw / 16
	node = self.rootnode
	self.constructrec(node, 16)

    def constructrec(self, node, minwidth):
	if node.w < minwidth:
		return
	for n in node.children:
		n.construct()
		self.constructrec(n)
			
