
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from playerentity import *
from stateimagelibrary import *
from widgettree import *
from explorewidgetwhitepegasus import *
from exploreandattackwidgetwhitepegasus import *
import random

class PegasusWhite(PlayerEntity):
    "Pegasus1"
    def __init__(self,xx,yy,maxattackdist):
	PlayerEntity.__init__(self, xx, yy,maxattackdist)
        self.w = 100 
        self.h = 100 
	self.stimlibleft = Stateimagelibrary()	
	self.stimlibright = Stateimagelibrary()	
        image = pygame.image.load('./pics/pegasus-white-2-100x100.png').convert()
        image.set_colorkey((255,255,255)) 
	self.stimlibleft.addpicture(image)	
        image = pygame.image.load('./pics/pegasus-white-1-100x100.png').convert()
        image.set_colorkey((255,255,255)) 
	self.stimlibright.addpicture(image)	
	self.direction = "left"
	self.hitpoints = 1 


    def hit(self):
	self.hitpoints -= 1
	if (self.hitpoints <= 0):
		print "collision!"

    def draw(self, screen, room):
	if self.hoverover:
        	screen.blit(self.hoverimage,((self.x+room.getrelativex())%640,(self.y+room.getrelativey())%480))
	if (self.direction == "left"):
            self.stimlibleft.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif (self.direction == "right"):
            self.stimlibright.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif (self.direction == "up"):
            self.stimlibleft.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif (self.direction == "down"):
            self.stimlibright.draw(screen, self.x+room.relativex,self.y+room.relativey)
	    
	     
    def update(self,room):
	if (random.randint(0,100) == 0 and self.direction == "left"):
	   if (random.randint(0,100) >= 50):
		self.direction = "right"
	   else:
		self.direction = "up"
	elif (random.randint(0,100) == 0 and self.direction == "right"):
	   if (random.randint(0,100) >= 50):
		self.direction = "left"
	   else:
		self.direction = "down"
	elif (random.randint(0,100) == 0 and self.direction == "up"):
	   if (random.randint(0,100) >= 50):
		self.direction = "down"
	   else:
	   	self.direction = "left"
	elif (random.randint(0,100) == 0 and self.direction == "down"):
	   if (random.randint(0,100) >= 50):
		self.direction = "up"
	   else:
	   	self.direction = "right"

	self.setcombatmode(room)	

#	if (not self.collideobjectX(room)): 
#	    if (self.direction == "up"):
#	        self.y +=2
#	        self.direction = "down" 
#	    elif (self.direction == "down"):
#	        self.y -=2
#	        self.direction = "up"
#	    if (self.direction == "right"):
#	        self.x +=2
#	        self.direction = "right" 
#	    elif (self.direction == "right"):
#	        self.x -=2
#	        self.direction = "right"


	if (self.direction == "right"):
	        self.x -=0.3 
	elif (self.direction == "right"):
	        self.x +=0.3
	elif (self.direction == "up"):
	        self.y +=0.3
	elif (self.direction == "down"):
	        self.y -=0.3

    def click(self, option):
	print "Pegasus clicked"
	option.widgettree = WidgetTreeSingleLayer()
	option.widgettree.add(ExploreWidgetWhitePegasus(544,4,96,96))
	option.widgettree.add(ExploreAndAttackWidgetWhitePegasus(544,104,96,96))
		 
