
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

import math

class PlayerGameobject(Gameobject):
    "Game object"
    def __init__(self, xx,yy,maxattackdist):
	Gameobject.__init__(self, xx,yy)
	self.combatmode = False
	self.maxattackdist = maxattackdist

	self.hoverover = False

    def setcombatmode(self, room):
	if self.combatmode:
		for e in room.getenemies():		
			if self.distance(e.getx(),e.gety(),self.getx(),self.gety()) > self.maxattackdist:
				self.combatmode = False			

	for e in room.getenemies():
		if self.distance(e.getx(),e.gety(),self.getx(),self.gety()) < self.maxattackdist:
 			self.combatmode = True

    def collide(self, mousetuple):
	r = 0
	if mousetuple[0] > self.x:
		r += 1
	if mousetuple[0] < self.x+self.w: 
		r += 1	
	if mousetuple[1] > self.y: 
		r += 1	
	if mousetuple[1] < self.y + self.h:
		r += 1
	return r - 3 

    def click(self, option):
	pass

    def hover(self, option=None):
	self.hoverover = True 

    def unhover(self, option=None):
	self.hoverover = False 

    def distance(self, x1,y1,x2,y2):
	return math.sqrt((y2-y1)*(y2-y1) + (x2-x1)*(x2-x1)) 
