#!/usr/local/bin/python
# Copyright (C) Johan Ceuppens 2010-2016
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom1 import *
from player import *
from playeraiengine import *
from widgettree import *
from startgamebuttonwidget import *
from tavernwidget import *
from explorewidgetwhitepegasus import *
from exploreandattackwidgetwhitepegasus import *
from explorewidgetteam import *
from exploreandattackwidgetteam import *
from loadgamebuttonwidget import *
from manaengine import *
from creditsengine import *

class Game:
    "Main function"
    def __init__(self):
        pygame.init()
        pygame.font.init()
        screen = pygame.display.set_mode((640, 480))
        font = pygame.font.SysFont("Vera", 32)
        self.gameover = 0
        blankimage = pygame.image.load('./pics/blank.bmp').convert()
        titleimage = pygame.image.load('./pics/titlescreen.bmp').convert()
        rightscreenimage = pygame.image.load('./pics/rightscreen1.png').convert()
        self.cursorimage = pygame.image.load('./pics/cursor1.png').convert()
        self.cursorimage.set_colorkey((255,255,255)) 
        self.x = 0
        self.y = 0
        self.room = Maproom1(0,0)

	self.creditsengine = CreditsEngine(50,80)
	self.manaengine = ManaEngine(50,80)

	self.player = Player()
	self.playeraiengine = PlayerAIEngine()

	self.widgettree = WidgetTreeSingleLayer()
	self.widgettree.add(StartGameButtonWidget(240,300,200,64))
	self.widgettree.add(LoadGameButtonWidget(240,380,200,64))
        while self.gameover == 0:
            pygame.display.update()
            screen.blit(titleimage, (0,0))
	    for idx in range(0, self.widgettree.getwidgets().length()):
			self.widgettree.getwidgets().get(idx).draw(screen)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                if event.type == pygame.MOUSEMOTION:
                    (mousex, mousey) = pygame.mouse.get_pos() 
                    widget = self.widgettree.hover(mousex, mousey)
	            if widget:
			widget.hover(self)
		    else:
		    	for idx in range(0, self.widgettree.getwidgets().length()):
				self.widgettree.getwidgets().get(idx).unhover()	
                if event.type == pygame.MOUSEBUTTONDOWN:
                    (mousex, mousey) = pygame.mouse.get_pos() 
                    widget = self.widgettree.click(mousex, mousey)	
		    if widget:
			widget.click(self)

	self.widgettree = WidgetTreeSingleLayer()
	###self.widgettree.add(ExploreWidgetWhitePegasus(544,4,96,96))
	###self.widgettree.add(ExploreAndAttackWidgetPegasus(544,104,96,96))


	self.selectteam = 0
	self.selectmousex = -1
	self.selectmousey = -1

        self.gameover = 0
        while self.gameover == 0:
	    self.room.update(self)
            self.room.draw(screen)

	    # NOTE : scroll at edges of screen	    
            (mousex, mousey) = pygame.mouse.get_pos() 
            if mousey < 10:
                self.room.movedown()    
            elif mousey > 470:
                self.room.moveup()    
            if mousex < 10:
                self.room.moveright()    
            elif mousex > 630:
                self.room.moveleft()    

            for event in pygame.event.get():

                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_UP:
                        self.room.movedown()    
                    elif event.key == K_DOWN:
                        self.room.moveup()    
                    elif event.key == K_LEFT:
                        self.room.moveright()    
                    elif event.key == K_RIGHT:
                        self.room.moveleft()    
                if event.type == pygame.MOUSEMOTION:
                    (mousex, mousey) = pygame.mouse.get_pos() 
                    widget = self.widgettree.hover(mousex, mousey)
	            if widget:
			widget.hover(self)
		    else:
		    	for idx in range(0, self.widgettree.getwidgets().length()):
				self.widgettree.getwidgets().get(idx).unhover()	
	    	    if self.selectteam == 1:
		    	pygame.draw.rect(screen, 0x00ff00, Rect(self.selectmousex,self.selectmousey,mousex,mousey),1) 
                if event.type == pygame.MOUSEBUTTONDOWN:
                   (mousex, mousey) = pygame.mouse.get_pos() 
            	   screen.blit(self.cursorimage, (mousex-32, mousey-32))
                   widget = self.widgettree.click(mousex, mousey)	
		   if widget:
			widget.click(self)
                   entity = self.room.collideforclick(self) 
	           if entity:
			entity.click(self)
		   else:
			self.widgettree = WidgetTreeSingleLayer()
			if entity == None:
				self.selectteam = 1				
				self.selectmousex = mousex
				self.selectmousey = mousey
                if event.type == pygame.MOUSEBUTTONUP:
			if self.selectteam == 1:
				self.widgettree = WidgetTreeSingleLayer()
				self.widgettree.add(ExploreWidgetTeam(544,4,96,96))
				self.widgettree.add(ExploreAndAttackWidgetTeam(544,104,96,96))
				self.playeraiengine.request("select team", (mousex,self.selectmousex), (mousey, self.selectmousey), self.room)
				self.selectteam = 0		
	
            self.room.collide(self.player)
            screen.blit(rightscreenimage, (540,0))

	    self.player.draw(screen,self.room)
	    
	    for idx in range(0, self.widgettree.getwidgets().length()):
			self.widgettree.getwidgets().get(idx).draw(screen)

	    if self.selectteam == 1:
	    	pygame.draw.rect(screen, 0x00ff00, Rect(self.selectmousex,self.selectmousey,mousex,mousey),1) 
	    self.creditsengine.draw(screen)
	    self.manaengine.draw(screen)

 
	    pygame.display.update()
            screen.blit(blankimage, (0,0))

#            roomnumber = self.room.exit(self)
#            self.chooseroom(roomnumber)

    def setxy(self,xx,yy):
        self.x = xx
        self.y = yy

if __name__ == "__main__":
    foo = Game()



