
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *

class Visibilitygraph:
    "Room with a (big) map"
    def __init__(self,x,y):
	self.graph = []
	self.tempgraph = []

    def addNode(self, xx, yy):
	self.graph.append((xx,yy))

    def addNodeToNewGraph(self, xx, yy):
	self.tempgraph.append((xx,yy))

    def constructGraph(self, buildings, playero, targetx, targety):
	for b in buildings:
		self.addNode(b.x, b.y)
	self.addNode(player.x, player.y)
	self.addNode(targetx, targety)

    def constructGraphToNewGraph(self, graph, playerx, playery, targetx, targety):
	for b in graph:
		self.addNodeToNewGraph(b[0], b[1])
	self.addNodeToNewGraph(playerx, playery)
	self.addNodeToNewGraph(targetx, targety)

    def shortestPath(self):
	playerx = self.graph[self.graph.length()-2][0]
	playery = self.graph[self.graph.length()-2][1]
	targetx = self.graph[self.graph.length()-1][0]
	targety = self.graph[self.graph.length()-1][1]
	min = 1000000000
	resultgraph = []
	for node in self.graph:
		self.tempgraph = []
		self.tempgraph.append(node)
		for node2 in self.graph:
			self.tempgraph.append(node2)
			self.constructGraphToNewGraph(graph, playerx, playery, targetx, targety)
			len = 0
			len = len + math.sqrt(playerx-graph[0][0]*
						playerx-graph[0][0]
						+playery-graph[0][1]*
						playery-graph[0][1])
			prevnode = graph[0]
			for node3 in self.tempgraph:
				len = math.sqrt(node3[0]-prevnode[0]*
						node3[0]-prevnode[0]
						+ node3[1]*prevnode[1]*
						node3[1]-prevnode[1])	
				prevnode = node3
			len = len + math.sqrt(targetx-graph[0][0]*
						targetx-graph[0][0]
						+targety-graph[0][1]*
						targety-graph[0][1])
			if len < min:
				min = len
				resultgraph = graph	
