
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from nodeslist import *
from widgetlist import *
from imagebuttonwidget import *

class WidgetTreeNode:
	def __init__(self):
		self.widgets = WidgetList()
		self.nodes = NodesList() 

	def getwidgets(self):
		return self.widgets

	def getnodes(self):
		return self.nodes

	def add(self, w):
		self.widgets.append(w)

class WidgetTreeSingleLayer:
    "WidgetTree 1 array of nodes"
    def __init__(self):
	self.root = WidgetTreeNode()

    def add(self, w):
	self.root.widgets.append(w)

    def getwidgets(self):
	return self.root.getwidgets()

    def click(self, mx,my):
	for idx in range(0,self.root.getwidgets().length()):
		if self.root.getwidgets().get(idx).collide((mx,my)) == 1:
			return self.root.getwidgets().get(idx)
	return None	
		
    def hover(self, mx,my):
	for idx in range(0,self.root.getwidgets().length()):
		if self.root.getwidgets().get(idx).collide((mx,my)) == 1:
			return self.root.getwidgets().get(idx)
	return None	

class WigetTree:
	"Widget Tree"	
	def __init__(self):
		self.root = WidgetTreeNode()

	### Breadth First Search 
	def  add(self, w):
		self.addrec(self.root)

	def addrec(self, w, tmprootnode):
		for idx in range(0,tmprootnode.getwidgets().length()):
			if tmprootnode.getwidgets().get(idx).collide((w.getx(),w.gety())) == 1:
				self.addrec(w, tmprootnode.getwidgets().get(idx))
			else:
				tmprootnode.add(w)
				return
		
	def click(self, mousetuple):
		self.clickrec(self.root, mousetuple)

	def clickrec(self, tmprootnode, mousetuple):
		for idx in range(0,tmprootnode.getwidgets().length()):
			if tmprootnode.getwidgets().get(idx).collide((mousetuple[0],mousetuple[1])) == 1:
				self.clickrec(w, tmprootnode.getnodes().get(idx))
			else:
				tmprootnode.add(w)
				return
		
	def hover(self, mousetuple):
		return self.hoverrec(self.root, mousetuple)

	def hoverrec(self, tmprootnode, mousetuple):
		for idx in range(0,tmprootnode.getwidgets().length()):
			if tmprootnode.getwidgets().get(idx).collide((w.getx(),w.gety())) == 1:
				self.addrec(w, tmprootnode.getnodes().get(idx))
			else:
				return tmprootnode.add(w)
		
