/*
 Copyright (C) Johan Ceuppens 2009-2011 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <SDL/SDL.h>
#include "eventloop.h"
#include "room.h"
#include "screen.h"
#include "player.h"
#include "octtree.h"

enum Direction {NOWHERE,LEFT,RIGHT,UP,DOWN};

static int mainloop(int argc, char **argv);
static int draw(Room *r, Screen *scr);
static int draw_player(Player *p, Screen *scr);


int main(int argc, char *argv[])
{ 
			
   mainloop(argc, argv);
  
}
			
static int draw(Room *r, Screen *scr)
{

SDL_Rect rect;
rect.x = - r->rb.relx;
rect.y = - r->rb.rely;
rect.w = 800;
rect.h = 800;
SDL_BlitSurface(r->bg, NULL, scr->scr, &rect);

}

static int draw_player(Player *p, Screen *scr)
{
	SDL_BlitSurface(p->surf1, NULL, scr->scr, &(p->rect));
}

static int work(Octtree *ot, Player *p)
{

	if (vision(ot, p)) {
		printf("Vision!");
	}
		

}

static int mainloop(int argc, char **argv)
{
  SDL_Init(SDL_INIT_EVERYTHING);

  SDL_Surface *screen = SDL_SetVideoMode(400,300,32, SDL_HWSURFACE | SDL_DOUBLEBUF);
  SDL_EnableKeyRepeat(5, 5);

  Player p = { NULL, NULL, };
  make_player(&p);

  Room r = { {0, 0,}, NULL };
  make_room(&r);

  Screen scr = { { 800, 800, }, screen };
  make_screen(&scr);

  Octtree octtree;
  make_octtree(&octtree);

  enum Direction direction = NOWHERE;

  SDL_Rect rect;
  rect.x = 0;
  rect.y = 0;
  rect.w = 800;
  rect.h = 800;

  do {    
  
  SDL_Event event;
  if ( SDL_PollEvent(&event))
      {


      int xx = 0;
      int yy = 0;
      Uint8 mousestate = SDL_GetMouseState(&xx, &yy);
		
      if (event.button.type == SDL_MOUSEBUTTONUP)
	{


	}

      switch (event.type) {
      case SDL_QUIT:{
	exit(0);
	break;
      }
      case SDL_KEYDOWN:{
	switch (event.key.keysym.sym) {
	case SDLK_ESCAPE:{
	  exit(99);
	  break;
	}
	case SDLK_q:{
	  exit(99);
	  break;
	}
	case SDLK_SPACE:{

	  break;
	}
	case SDLK_LEFT:{
	  direction = LEFT;
	  break;
	}
	case SDLK_RIGHT:{
	  direction = RIGHT;

	  break;
	}
	case SDLK_UP:{
	  direction = UP;
	  break;
	}
	  
	case SDLK_DOWN:{
	  direction = DOWN;

	  break;
	  }
	case SDLK_b:{
	  break;
	}
	case SDLK_k:{
	  
	  break;
	}
	default:{
	 
	  break;
	}
	}
	  
	

	
      }
      }
      
      
      
      
      } else {
    
	}
    switch (direction){
	case LEFT:{
		r.rb.relx += 1;
		break;
	}
	case RIGHT:{
		r.rb.relx -= 1;
		break;
	}
	case UP:{
		r.rb.rely += 1;
		break;
	}
	case DOWN:{
		r.rb.rely -= 1;
		break;
	}
	case NOWHERE:
	default:{
		break;
	}
	}
    draw(&r, &scr);
    draw_player(&p, &scr);

    work(&octtree, &p);
 
    SDL_Flip(scr.scr);
    SDL_FillRect(scr.scr, &rect, 0x0);

    direction = NOWHERE;

  } while (1);
}


