/*
 Copyright (C) Johan Ceuppens 2009-2011 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "octtree.h"
#include "player.h"

int construct(OcttreeNode *n, void *data);

int make_octtree(Octtree *t)
{

	t->rootnode = (OcttreeNode *)malloc(sizeof(OcttreeNode));
	t->x = 0;
	t->y = 0;
	t->w = MAPWIDTH;

	construct_tree(t);
}

int construct_tree(Octtree *t)
{
	t->rootnode->nodes = NULL;
	make_octtreenode(t->rootnode);
	depthsearchf(t->rootnode, construct, NULL);
}

int depthsearchf(OcttreeNode *n, int (*cb)(OcttreeNode *, void *), void *data)
{
	int j;

	for (j = 0; j < 16; j++) {
		(*cb)(n, NULL);
		if (n->w < 4*16)
			return;
		depthsearchf(n->nodes, construct, NULL);
		n->nodes++;
	}
}

int construct(OcttreeNode *n, void *data)
{
	make_octtreenode(n->nodes);
}

int vision(Octtree *ot, Player *p)
{

}
